<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\{ Utils, ExpectedException };
use Ems\Services\OcorrenciaService;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoAprovaHorasExtras extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrvinculom = $this->getSolicitacao()->getNrvinculom();
        $nrorg = Utils::getParamters()->getNrorg();
        $dataAprovacaoHE = $itens['DTAPROVAHE'] ?? null;

        if (empty($dataAprovacaoHE)) {
            throw new ExpectedException('A data de aprovação deve ser preenchida. Se necessário, crie uma nova solicitação');
        }

        $dateTimeAprovacaoHE = DateUtil::getDataDeString($dataAprovacaoHE, DateUtil::FORMATO_BRASILEIRO, true);

        /* Validacao existencia de ocorrencias */

        /*
        $ocorrenciaJaExistente = Utils::getEntityManager()->getRepository(Repositories::PTO_PROGOCORRENCIA)->findOneBy([
            'nrorg' => $nrorg, 'nrvinculom' => $nrvinculom, 'dtinicioprogocor' => $dateTimeAprovacaoHE,
            'nrtipoprogocorrencia' => OcorrenciaService::NRTIPOPROGOCORRENCIA_SOLICITACAOHORASEXTRAS
        ]);

        if (!empty($ocorrenciaJaExistente)) {
            throw new ExpectedException('Já existe uma ocorrência de aprovação de horas extras no dia solicitado');
        }
        */

        /* Criacao da ocorrencia */

        $this->criaOcorrenciaAprovacaoHE($dataAprovacaoHE);
    }
    
    public function rejeitar() {}

    private function criaOcorrenciaAprovacaoHE(
        string $dataAprovacaoHE
    ) {
        try {
            Utils::getInstanceByClassName(OcorrenciaService::class)->solicitarHorasExtras(
                $this->getSolicitacao()->getNrvinculom(),
                'Ocorrência criada pela aprovação da solicitação ' . $this->getSolicitacao()->getNrsolicitacao(),
                null,
                $dataAprovacaoHE,
                OcorrenciaService::APROVAHE_NAO_VALIDA_EXISTENCIA_CALCULO,
                OcorrenciaService::APROVAHE_NAO_EXIGE_APROVACAO
            );
        } catch (\Exception $e) {
            throw new ExpectedException($e->getMessage());
        }
    }
}