<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Geral\Entity\GpeParamestrutmEntity;
use HCM\FPA\Entity\FpaParamfolhamEntity;
use HCM\FPA\Entity\FpaParamferiasmEntity;
class ParametrosCalculo {


    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;
    private $_paramEstrutura;
    private $_paramFolha;
    private $_paramFerias;
    private $_nrParamFolha;
    private $_nrParamFerias;

    public function __construct($entityManager, $hcmParameters) {

        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();
        $this->_paramEstrutura = new GpeParamestrutmEntity($entityManager, $hcmParameters);
        $this->_paramFolha = new FpaParamfolhamEntity($entityManager, $hcmParameters);
        $this->_paramFerias = new FpaParamferiasmEntity($entityManager, $hcmParameters);
    }

    public function getParamFolha() {
        return $this->_paramFolha;
    }

    public function getParamFerias() {
        return $this->_paramFerias;
    }

    public function carregaParametroEstrutura($nrEstrutura) {

        $this->_paramEstrutura->carregaParametrosEstrutra($nrEstrutura);
        $this->_nrParamFolha = $this->_paramEstrutura->getNrParamFolha();
        $this->_nrParamFerias = $this->_paramEstrutura->getNrParamFerias();
    }

    public function carregaParametroFolha() {
        $this->_paramFolha->procuraParamFolha($this->_nrParamFolha);
    }

    public function carregaParametroFerias() {
        $this->_paramFerias->procuraParamFerias($this->_nrParamFerias);
    }
}