<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomSituFuncRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */

    public function getRelatCustomSituFunc($parameters) {
        
        $sql = "
 SELECT           
        TER.*  
          FROM  (SELECT
              SEC.*,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM = 100051 /*100051 - Suspensão*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASSUSPENSAO,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM IN ( 100041, 100044 ) /*100041 - Suspensao Lei 14.020/2020 (Com Ajuda Compensatória)
                                                                100044 - Suspensao Lei 14.020/2020 (Sem Ajuda Compensatória)*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASSUSPENSAO14020,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM IN (12, 15, 6, 100042, 9, 100006) /*12 Atestado Médico
                                                                            15 Afastamento doença - 15 dias de responsabilidade do empregador
                                                                            6 Afastamento Doença Superior 15 Dias
                                                                            100042 Atestado Médico - Covid19
                                                                            9 Novo afastamento temporário em decorrência da mesma doença, dentro de 60 dias;
                                                                            100006 Doença*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASAFASTDOENCA,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM IN (3, 16) /*3 Afastamento Acidente Trabalho Superior 15 Dias
                                                    16 Afastamento acidente - 15 dias de responsabilidade do empregador*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASAFASTACIDENT,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM IN (5, 11) /*5 Afastamento Licença Gestante
                                                     11 Prorrogação Afastamento Licença Gestante*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASAFASTMATERNID,
              ( SELECT SUM(ASF.NRQTDIASITUFUNC)
                  FROM GPE_ALTESITUFUNC ASF
                  JOIN GPE_SITUFUNCH SFH ON SFH.NRORG IN (0, SEC.NRORG)
                                        AND SFH.NRSITUFUNCM     = ASF.NRSITUFUNCM
                                        AND SFH.IDAFASTSITUFUNC = 'S'
                                        AND SFH.DTEFETIVA       = ( SELECT MAX(DTEFETIVA) FROM GPE_SITUFUNCH
                                                                    WHERE NRORG           = SFH.NRORG
                                                                      AND NRSITUFUNCM     = SFH.NRSITUFUNCM
                                                                      AND IDAFASTSITUFUNC = SFH.IDAFASTSITUFUNC
                                                                      AND DTEFETIVA      <= :P_DTMESCOMPETENC )
                  WHERE ASF.NRORG = SEC.NRORG
                    AND ASF.NRSITUFUNCM NOT IN (100051, /*DIASSUSPENSAO*/
                                                100041, 100044, /*DIASSUSPENSAO14020*/
                                                12, 15, 6, 100042, 9, 100006, /*DIASAFASTDOENCA*/
                                                3, 16, /*DIASAFASTACIDENT*/
                                                5, 11) /*DIASAFASTMATERNID*/
                    AND ASF.NRVINCULOM = SEC.NRVINCULOM
                    AND ASF.DTINISITUFUNC >= SEC.DTINICIO
                    AND ASF.DTFIMSITUFUNC <= SEC.DTFINAL ) DIASAFASTOUTROS,
              EHL.NMRAZSOCESTRUT NMRAZSOCESTRUTLEGAL,
              EHL.CDCNPJESTRUT   CDCNPJESTRUTLEGAL,
              EHG.NMRAZSOCESTRUT NMRAZSOCESTRUTGEREN
            FROM (SELECT
                    PRI.NRORG,
                    PRI.NRVINCULOM,
                    PRI.NMVINCULOM,
                    PRI.NRESTRUTLEGAL,
                    PRI.NRESTRUTGEREN,
                    PRI.CDMATRICULA,
                    PRI.DTADMISSAOVINC,
                    PRI.NRCPFPESSOA,
                    PRI.DTNASCPESSOA,
                    PRI.CDMATRICULAESOCIAL,
                    PRI.NROCUPACAOM,
                    PRI.NMOCUPACAOH,
                    PRI.DTINIOCUPACAO,
                    PRI.NRSITUFUNCM,
                    PRI.NMSITUFUNCH,
                    NVL( COUNT( PRI.DTOCORRENCIA ), 0 ) QDEMESES,
                    SUM( PRI.HORAFALTAS )  HORAFALTAS,
                    SUM( PRI.DIAFALTAS  )  DIAFALTAS,
                    TRUNC(    TO_DATE( NVL( :P_DTINICIO, :P_DTMESCOMPETENC ), 'DD/MM/YYYY' ), 'DD' ) DTINICIO,
                    LAST_DAY( TO_DATE( NVL( :P_DTFINAL,  :P_DTMESCOMPETENC ), 'DD/MM/YYYY' ) )       DTFINAL
                  FROM (SELECT
                          VM.NRORG,
                          VM.NRVINCULOM,
                          VM.NMVINCULOM,
                          REPLACE( TRANSLATE (VM.CDMATRICULA, '~!@#$%^&*_-+=|\(){}[]:;<>,.?/' , ' ' ), ' ', '' ) CDMATRICULA,
                          VM.DTADMISSAOVINC,
                          PH.NRCPFPESSOA,
                          PH.DTNASCPESSOA,
                          VH.NRESTRUTLEGAL,
                          VH.NRESTRUTGEREN,
                          VH.CDMATRICULAESOCIAL,
                          AO.NROCUPACAOM,
                          OH.NMOCUPACAOH,
                          AO.DTINIOCUPACAO,
                          GPE_SITUFUNCM.NRSITUFUNCM,
                          GPE_SITUFUNCH.NMSITUFUNCH,
                          CF.DTOCORRENCIA,
                          SUM( DECODE( ICF.NREVENTOM, 10, ICF.VRREFFOLHA, 
                                                      20, TRUNC( ICF.VRREFFOLHA/ ETH.QTHRESCALATRABH),
                                                     810, ICF.VRREFFOLHA, 
                                                     818, ICF.VRREFFOLHA, 
                                                     210, ICF.VRREFFOLHA, 
                                                     220, ICF.VRREFFOLHA, 
                                                     880, ICF.VRREFFOLHA, 
                                                     450, ICF.VRREFFOLHA, 
                                                     460, ICF.VRREFFOLHA, 
                                                     440, ICF.VRREFFOLHA,                                 
                                                     445, ICF.VRREFFOLHA,
                                                     0 ) ) DIASTRAB,
                         SUM(
                           DECODE( EH.IDFALTASFERIAS, 'SOMA',         DECODE( EH.IDUNIDREFEREVEN, 'HORA', ICF.VRREFFOLHA ),
                                                      'SUBTRAI', -1 * DECODE( EH.IDUNIDREFEREVEN, 'HORA', ICF.VRREFFOLHA ) ) ) HORAFALTAS,
                          SUM(
                            DECODE( EH.IDFALTASFERIAS, 'SOMA',         DECODE( EH.IDUNIDREFEREVEN, 'DIA', ICF.VRREFFOLHA ),
                                                       'SUBTRAI', -1 * DECODE( EH.IDUNIDREFEREVEN, 'DIA', ICF.VRREFFOLHA ) ) ) DIAFALTAS
                        FROM GPE_VINCULOM VM
                        JOIN GPE_VINCULOH VH ON VH.NRORG          = VM.NRORG
                                            AND VH.NRVINCULOM     = VM.NRVINCULOM
                                            AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                                     WHERE NRORG          = VH.NRORG
                                                                       AND NRVINCULOM     = VH.NRVINCULOM
                                                                       AND DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                                            AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0 OR :P_NRESTRUTLEGAL IS NULL )
                                            AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0 OR :P_NRESTRUTGEREN IS NULL )
                        LEFT JOIN GPE_PESSOAH PH ON PH.NRORG      = VM.NRORG
                                            AND PH.NRPESSOA       = VM.NRPESSOA
                                            AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                                                                         WHERE NRORG          = PH.NRORG
                                                                                           AND NRPESSOA       = PH.NRPESSOA
                                                                                           AND DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                        LEFT JOIN GPE_ESCALATRABH ETH ON ETH.NRORG          = VM.NRORG
                                                     AND ETH.NRESCALATRABM  = VH.NRESCALATRABM
                                                     AND ETH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                                               WHERE NRORG          = ETH.NRORG
                                                                                 AND NRESCALATRABM  = ETH.NRESCALATRABM
                                                                                 AND DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                        /*ALTERAÇÃO DE OCUPAÇÃO - CARGO E FUNÇÃO*/
                        LEFT JOIN GPE_ALTEOCUPACAO AO ON AO.NRORG      = VM.NRORG
                                                     AND AO.NRVINCULOM = VM.NRVINCULOM
                                                     AND AO.DTINIOCUPACAO = ( SELECT MAX(DTINIOCUPACAO) FROM GPE_ALTEOCUPACAO
                                                                              WHERE NRORG          = AO.NRORG
                                                                                AND NRVINCULOM     = AO.NRVINCULOM
                                                                                AND DTINIOCUPACAO <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')) )
                        LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG          = VM.NRORG
                                                  AND OH.NROCUPACAOM    = AO.NROCUPACAOM
                                                  AND OH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                                            WHERE NRORG           = OH.NRORG
                                                                              AND NROCUPACAOM     = AO.NROCUPACAOM
                                                                              AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY') )
                        /* SITUAÇÃO FUNCIONAL*/
                        LEFT JOIN GPE_ALTESITUFUNC
                                ON GPE_ALTESITUFUNC.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_ALTESITUFUNC.NRORG = VM.NRORG
                               AND GPE_ALTESITUFUNC.NRSITUFUNCM <> 12
                               AND GPE_ALTESITUFUNC.DTINISITUFUNC = (SELECT MAX(MAX_ALTESITUFUNC.DTINISITUFUNC)
                                                                    FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                                   WHERE MAX_ALTESITUFUNC.NRVINCULOM = GPE_ALTESITUFUNC.NRVINCULOM
                                                                     AND MAX_ALTESITUFUNC.NRORG = GPE_ALTESITUFUNC.NRORG
                                                                     AND MAX_ALTESITUFUNC.NRSITUFUNCM <> 12
                                                                     AND MAX_ALTESITUFUNC.DTINISITUFUNC <= LAST_DAY(:P_DTMESCOMPETENC))
            
                        LEFT JOIN GPE_SITUFUNCM
                            ON GPE_SITUFUNCM.NRSITUFUNCM = GPE_ALTESITUFUNC.NRSITUFUNCM
                            AND (GPE_SITUFUNCM.NRORG = GPE_ALTESITUFUNC.NRORG OR GPE_SITUFUNCM.NRORG = :P_NRORG_PADRAO OR GPE_SITUFUNCM.NRORG IS NULL)
                        LEFT JOIN GPE_SITUFUNCH
                            ON GPE_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCM.NRSITUFUNCM
                            AND (GPE_SITUFUNCH.NRORG = GPE_SITUFUNCM.NRORG OR GPE_SITUFUNCH.NRORG = :P_NRORG_PADRAO OR GPE_SITUFUNCH.NRORG IS NULL)
                            AND GPE_SITUFUNCH.DTEFETIVA = (SELECT MAX(MAX_SITUFUNCH.DTEFETIVA)
                                                             FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                                            WHERE MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM
                                                              AND MAX_SITUFUNCH.DTEFETIVA <= :P_DTMESCOMPETENC)
                        JOIN FPA_CALCULOFOLHA CF ON CF.NRORG          = VM.NRORG
                                                AND CF.NRTIPOMOVIMENT = 1 --Mensal
                                                AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
                                                AND CF.NROCORRECAL    = :P_NROCORRECAL
                                                AND CF.DTOCORRENCIA >= TRUNC( TO_DATE( NVL( :P_DTINICIO, :P_DTMESCOMPETENC ), 'DD/MM/YYYY' ), 'DD' )
                                                AND CF.DTOCORRENCIA <= TRUNC( TO_DATE( NVL( :P_DTFINAL,  :P_DTMESCOMPETENC ), 'DD/MM/YYYY' ), 'DD' )
                        JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG          = CF.NRORG
                                                 AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                                 AND ICF.NRVINCULOM     = VM.NRVINCULOM
                        JOIN FPA_EVENTOH EH ON EH.NREVENTOM      = ICF.NREVENTOM
                                           AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH
                                                                    WHERE NREVENTOM      = EH.NREVENTOM 
                                                                      AND DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                        WHERE VM.NRORG      = :P_NRORG
                          AND ( VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC )
                          AND ( INSTR(','||:P_NRVINCULO||',', ','||VM.NRVINCULOM||',' ) > 0 OR :P_NRVINCULO IS NULL ) /*lista de vínculos*/
                        GROUP BY VM.NRORG, VM.NRVINCULOM, VM.NMVINCULOM, VM.CDMATRICULA, VM.DTADMISSAOVINC, PH.NRCPFPESSOA, PH.DTNASCPESSOA, VH.CDMATRICULAESOCIAL, AO.NROCUPACAOM, OH.NMOCUPACAOH, AO.DTINIOCUPACAO, GPE_SITUFUNCM.NRSITUFUNCM, GPE_SITUFUNCH.NMSITUFUNCH, CF.DTOCORRENCIA, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN
                  ) PRI
                  WHERE PRI.DIASTRAB BETWEEN :P_QDEDIASMIN AND :P_QDEDIASMAX
                  AND ( PRI.HORAFALTAS >= :P_HORAFALTASMIN OR :P_HORAFALTASMIN IS NULL )
                  AND ( PRI.HORAFALTAS <= :P_HORAFALTASMAX OR :P_HORAFALTASMAX IS NULL )
                  AND ( PRI.DIAFALTAS  >= :P_DIAFALTASMIN  OR :P_DIAFALTASMIN  IS NULL )
                  AND ( PRI.DIAFALTAS  <= :P_DIAFALTASMAX  OR :P_DIAFALTASMAX  IS NULL )
                  GROUP BY PRI.NRORG, PRI.NRVINCULOM, PRI.NMVINCULOM, PRI.CDMATRICULA, PRI.DTADMISSAOVINC, PRI.NRCPFPESSOA, PRI.DTNASCPESSOA,  PRI.CDMATRICULAESOCIAL, PRI.NROCUPACAOM, PRI.NMOCUPACAOH, PRI.DTINIOCUPACAO, PRI.NRSITUFUNCM, PRI.NMSITUFUNCH, PRI.NRESTRUTLEGAL, PRI.NRESTRUTGEREN
            ) SEC
            /*Estrutura legal e Gerencial*/
            LEFT JOIN ESTRUTURAH EHL ON EHL.NRORG        = SEC.NRORG
                                    AND EHL.NRESTRUTURAM = SEC.NRESTRUTLEGAL
                                    AND EHL.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND NRORG        = EHL.NRORG
                                                                 AND NRESTRUTURAM = EHL.NRESTRUTURAM )
            LEFT JOIN ESTRUTURAH EHG ON EHG.NRORG        = SEC.NRORG
                                    AND EHG.NRESTRUTURAM = SEC.NRESTRUTGEREN
                                    AND EHG.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                               WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND NRORG        = EHG.NRORG
                                                                 AND NRESTRUTURAM = EHG.NRESTRUTURAM )
            ORDER BY SEC.NMVINCULOM 
) TER 
    WHERE ( TER.DIASSUSPENSAO      >= :P_DIASSUSPENSAOMIN       OR :P_DIASSUSPENSAOMIN      IS NULL )
    AND   ( TER.DIASSUSPENSAO      <= :P_DIASSUSPENSAOMAX       OR :P_DIASSUSPENSAOMAX      IS NULL )
    AND   ( TER.DIASAFASTDOENCA    >= :P_DIASAFASTDOENCAMIN     OR :P_DIASAFASTDOENCAMIN    IS NULL )
    AND   ( TER.DIASAFASTDOENCA    <= :P_DIASAFASTDOENCAMAX     OR :P_DIASAFASTDOENCAMAX    IS NULL )
    AND   ( TER.DIASSUSPENSAO14020 >= :P_DIASSUSPENSAO14020MIN  OR :P_DIASSUSPENSAO14020MIN IS NULL )
    AND   ( TER.DIASSUSPENSAO14020 <= :P_DIASSUSPENSAO14020MAX  OR :P_DIASSUSPENSAO14020MAX IS NULL )
    AND   ( TER.DIASAFASTMATERNID  >= :P_DIASAFASTMATERNIDMIN   OR :P_DIASAFASTMATERNIDMIN  IS NULL )
    AND   ( TER.DIASAFASTMATERNID  <= :P_DIASAFASTMATERNIDMAX   OR :P_DIASAFASTMATERNIDMAX  IS NULL )
    ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($parameters);
        
        return $query->fetchAll();
    }
    
}

