<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class MovimentacaoRepository {

      public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
      }

      public function getMovimentacaoCrud($nrorg, $nrorg_padrao, $dtmescompetenc, $conditions, $orderBy) {   
        
            $params = array("P_DTMESCOMPETENC" => $dtmescompetenc,
                           "P_NRORG"            => $nrorg,
                           "P_NRORG_PADRAO" => $nrorg_padrao);
        
$query = <<<SQL
         SELECT * 
   FROM (SELECT
                (SELECT NMESTRUTURAH
                   FROM ESTRUTURAH EHL
                  WHERE EHL.NRORG = RES.NRORG
                        AND EHL.NRESTRUTURAM = RES.NRESTRUTLEGAL_ANT
                        AND EHL.DTMESCOMPETENC =  (SELECT MAX(DTMESCOMPETENC)
                                                     FROM ESTRUTURAH
                                                    WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                          AND NRORG = EHL.NRORG
                                                          AND NRESTRUTURAM = EHL.NRESTRUTURAM)) NMESTRUTLEGAL_ANT__LABEL, 
                    (SELECT NMESTRUTURAH
                       FROM ESTRUTURAH EHL
                      WHERE EHL.NRORG = RES.NRORG
                            AND EHL.NRESTRUTURAM = RES.NRESTRUTGEREN_ANT
                            AND EHL.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                        FROM ESTRUTURAH
                                                       WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                             AND NRORG = EHL.NRORG
                                                             AND NRESTRUTURAM = EHL.NRESTRUTURAM )) NMESTRUTGEREN_ANT__LABEL, RES.*
          FROM (SELECT 
                        (SELECT DISTINCT FIRST_VALUE(NRESTRUTURAM)
                            OVER (ORDER BY DTINIMOVIMENT DESC)
                           FROM GPE_MOVIMENTACAO M
                          WHERE M.NRORG = GPE_MOVIMENTACAO.NRORG
                                AND M.NRVINCULOM = GPE_MOVIMENTACAO.NRVINCULOM
                                AND M.DTINIMOVIMENT <= GPE_MOVIMENTACAO.DTINIMOVIMENT
                                AND M.NRMOVIMENTACAO != GPE_MOVIMENTACAO.NRMOVIMENTACAO
                                AND M.NRTIPOTRANSFER = 1 ) NRESTRUTLEGAL_ANT, 
                        (SELECT DISTINCT FIRST_VALUE(NRESTRUTURAM)
                            OVER (ORDER BY DTINIMOVIMENT DESC)
                           FROM GPE_MOVIMENTACAO M
                           WHERE M.NRORG = GPE_MOVIMENTACAO.NRORG
                                 AND M.NRVINCULOM = GPE_MOVIMENTACAO.NRVINCULOM
                                 AND M.DTINIMOVIMENT <= GPE_MOVIMENTACAO.DTINIMOVIMENT
                                 AND M.NRMOVIMENTACAO != GPE_MOVIMENTACAO.NRMOVIMENTACAO
                                 AND M.NRTIPOTRANSFER = 2 ) NRESTRUTGEREN_ANT, 
                        GPE_MOVIMENTACAO.*, 
                        GPE_VINCULOM.NMVINCULOM, 
                        ESTRUTURAH.NMESTRUTURAH, 
                        TIPOESTRUTURA.NMTIPOESTRUTURA, 
                        GPE_TIPOTRANSFER.NMTIPOTRANSFER, 
                        GPE_TPMOVTRANSFH.NMTPMOVTRANSFH, 
                        GPE_MOTIVOTRANSF.NMMOTIVOTRANSF
                  FROM GPE_MOVIMENTACAO
                  JOIN GPE_VINCULOM ON GPE_VINCULOM.NRVINCULOM = GPE_MOVIMENTACAO.NRVINCULOM
                                   AND GPE_VINCULOM.NRORG = GPE_MOVIMENTACAO.NRORG
                  JOIN GPE_VINCULOH ON GPE_VINCULOH.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                   AND GPE_VINCULOH.NRORG = GPE_VINCULOM.NRORG
                                   AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                                        FROM GPE_VINCULOH H1
                                                                       WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                                AND H1.NRORG = GPE_VINCULOH.NRORG
                                                                                AND H1.NRVINCULOM = GPE_VINCULOH.NRVINCULOM )
                  JOIN ESTRUTURAM ON ESTRUTURAM.NRORG = GPE_MOVIMENTACAO.NRORG
                                 AND ESTRUTURAM.NRESTRUTURAM = GPE_MOVIMENTACAO.NRESTRUTURAM
                                 /*AND ESTRUTURAM.NRTIPOESTRUTURA = GPE_MOVIMENTACAO.NRTIPOESTRUTURA*/
                  JOIN ESTRUTURAH ON ESTRUTURAH.NRESTRUTURAM = ESTRUTURAM.NRESTRUTURAM
                                 AND ESTRUTURAH.NRORG = ESTRUTURAM.NRORG
                                 AND ESTRUTURAH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                                    FROM ESTRUTURAH H1
                                                                   WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                            AND H1.NRORG = ESTRUTURAH.NRORG
                                                                            AND H1.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM )
                  JOIN TIPOESTRUTURA ON TIPOESTRUTURA.NRTIPOESTRUTURA = GPE_MOVIMENTACAO.NRTIPOESTRUTURA
                                    AND (TIPOESTRUTURA.NRORG = GPE_MOVIMENTACAO.NRORG OR TIPOESTRUTURA.NRORG = :P_NRORG_PADRAO)
             LEFT JOIN GPE_TIPOTRANSFER ON GPE_TIPOTRANSFER.NRTIPOTRANSFER = GPE_MOVIMENTACAO.NRTIPOTRANSFER
                                       AND (GPE_TIPOTRANSFER.NRORG = GPE_MOVIMENTACAO.NRORG OR GPE_TIPOTRANSFER.NRORG = :P_NRORG_PADRAO)
             LEFT JOIN GPE_TPMOVTRANSFH ON GPE_TPMOVTRANSFH.NRTPMOVTRANSFM = GPE_MOVIMENTACAO.NRTPMOVTRANSFM
                                       AND (GPE_TPMOVTRANSFH.NRORG = GPE_MOVIMENTACAO.NRORG OR GPE_TPMOVTRANSFH.NRORG = :P_NRORG_PADRAO)
                                       AND GPE_TPMOVTRANSFH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                                                FROM GPE_TPMOVTRANSFH MT
                                                                               WHERE MT.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                                        AND MT.NRORG = GPE_TPMOVTRANSFH.NRORG
                                                                                        AND MT.NRTPMOVTRANSFM = GPE_TPMOVTRANSFH.NRTPMOVTRANSFM )
             LEFT JOIN GPE_MOTIVOTRANSF ON GPE_MOTIVOTRANSF.NRMOTIVOTRANSF = GPE_MOVIMENTACAO.NRMOTIVOTRANSF
                                       AND (GPE_MOTIVOTRANSF.NRORG = GPE_MOVIMENTACAO.NRORG OR GPE_MOTIVOTRANSF.NRORG = :P_NRORG_PADRAO)
                 WHERE GPE_MOVIMENTACAO.NRORG = :P_NRORG) RES
            ORDER BY NMVINCULOM ASC, DTINIMOVIMENT DESC)
        WHERE 1 = 1
        $conditions $orderBy
SQL;
            $result = $this->connection->fetchAll($query, $params);
            
            return $result;
      }

    /**
     * @param $nrorg
     * @param $nrtipoestrutura
     * @param $nrvinculom
     * @return GpemovimentacaoEntity
     */
    public function getMovimentacao($nrorg, $nrtipoestrutura, $nrvinculom, $nrtipotransfer = null) {
        $dtmescompetencia = $this->hcmParameters->getUltimoDiaMes();
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $sql = <<<SQL
SELECT m FROM $gpeMovimentacao m
WHERE m.nrorg           = :nrorg
  AND m.nrtipoestrutura = :nrtipoestrutura
  AND m.nrvinculom      = :nrvinculom
  AND m.dtinimoviment   = (SELECT MAX(m2.dtinimoviment)
                          FROM $gpeMovimentacao m2
                         WHERE m2.nrorg           = :nrorg
                           AND m2.nrtipoestrutura = :nrtipoestrutura
                           AND m2.nrvinculom      = :nrvinculom
                           AND m2.dtinimoviment  <= :dtinimoviment
                           AND (m2.nrtipotransfer  = :nrtipotransfer OR :nrtipotransfer IS NULL))
SQL;

        $params = array('nrorg'=>$nrorg, 'nrtipoestrutura'=>$nrtipoestrutura, 'nrvinculom'=>$nrvinculom, 'dtinimoviment'=>$dtmescompetencia, 'nrtipotransfer'=>$nrtipotransfer);

        $result = $this->entityManager->createQuery($sql)->execute($params);
        
        if(isset($result[0])) 
            return $result[0];
        else
            return null;
    }
    
    public function retornaUltSaidaAntDtInicio($nrorg, $nrvinculom, $nrtipoestrutura, $nrestruturam, $nrtipotransfer, $dtinimoviment){
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        // 9 = Saída
        $sql = <<<SQL
SELECT m FROM $gpeMovimentacao m
WHERE m.nrorg = :P_NRORG
    AND m.nrvinculom      = :P_NRVINCULOM
    AND m.dtinimoviment   = :P_DTINIMOVIMENT
    AND m.nrtipotransfer  = :P_NRTIPOTRANSFER
    AND m.nrestruturam    = :P_NRESTRUTURAM
    AND m.nrtpmovtransfm  = 9
SQL;
        
        $params = array(
            'P_NRORG'           => $nrorg,
            'P_NRVINCULOM'      => $nrvinculom,
            'P_DTINIMOVIMENT'   => $dtinimoviment,
            'P_NRESTRUTURAM'    => $nrestruturam,
            'P_NRTIPOTRANSFER'  => $nrtipotransfer
        );
        
        $result = $this->entityManager->createQuery($sql)->execute($params);
        
        if(isset($result[0])) 
            return $result[0];
        else
            return null;
    }
    
    public function retornaUltMovDtFim($nrorg, $nrvinculom, $nrtipoestrutura, $nrestruturam, $nrtipotransfer, $dtfimSaida){
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        
        $sql = <<<SQL
SELECT m FROM $gpeMovimentacao m
WHERE m.nrorg = :P_NRORG
    AND m.nrvinculom      = :P_NRVINCULOM
    AND m.dtfimmoviment   = :P_DTFIMMOVIMENT
    AND m.nrtipotransfer  = :P_NRTIPOTRANSFER
    AND m.nrtpmovtransfm  != 9
    
SQL;
        
        $params = array(
            'P_NRORG'           => $nrorg,
            'P_NRVINCULOM'      => $nrvinculom,
            'P_DTFIMMOVIMENT'   => $dtfimSaida,
            'P_NRTIPOTRANSFER'  => $nrtipotransfer
        );
        
        $result = $this->entityManager->createQuery($sql)->execute($params);
        
        if(isset($result[0])) 
            return $result[0];
        else
            return null;
    }
    
    public function retornaMovGerenAnterior($nrorg, $nrvinculom, $nrtipoestrutura, $nrestruturam, $nrtipotransfer, $dtinimoviment){
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        
        $sql = <<<SQL
SELECT m FROM $gpeMovimentacao m
WHERE m.nrorg = :P_NRORG
    AND m.nrvinculom      = :P_NRVINCULOM
    AND m.dtinimoviment   < :P_DTINIMOVIMENT
    AND m.nrtipotransfer  = :P_NRTIPOTRANSFER
SQL;
        
        $params = array(
            'P_NRORG'           => $nrorg,
            'P_NRVINCULOM'      => $nrvinculom,
            'P_DTINIMOVIMENT'   => $dtinimoviment,
            'P_NRTIPOTRANSFER'  => $nrtipotransfer
        );
        
        $result = $this->entityManager->createQuery($sql)->execute($params);
        
        if(isset($result[0])) 
            return $result[0];
        else
            return null;
    }
    
    /**
     * @param $nrorg
     * @param $nrtipoestrutura
     * @param $nrvinculom
     * @return GpemovimentacaoEntity
     */
    public function getMovimentacaoEntrada($nrorg, $nrtipoestrutura, $nrvinculom, $nrtipotransfer = null) {
        $dtmescompetencia = $this->hcmParameters->getUltimoDiaMes();
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $sql = <<<SQL
SELECT m FROM $gpeMovimentacao m
WHERE m.nrorg           = :nrorg
  AND m.nrtipoestrutura = :nrtipoestrutura
  AND m.nrvinculom      = :nrvinculom
  AND m.nrtpmovtransfm != 9
  AND m.dtinimoviment   = (SELECT MAX(m2.dtinimoviment)
                          FROM $gpeMovimentacao m2
                         WHERE m2.nrorg           = :nrorg
                           AND m2.nrtipoestrutura = :nrtipoestrutura
                           AND m2.nrvinculom      = :nrvinculom
                           AND m2.nrtpmovtransfm != 9
                           AND m2.dtinimoviment  <= :dtinimoviment
                           AND (m2.nrtipotransfer  = :nrtipotransfer OR :nrtipotransfer IS NULL))
SQL;

        $params = array('nrorg'=>$nrorg, 'nrtipoestrutura'=>$nrtipoestrutura, 'nrvinculom'=>$nrvinculom, 'dtinimoviment'=>$dtmescompetencia, 'nrtipotransfer'=>$nrtipotransfer);

        $result = $this->entityManager->createQuery($sql)->execute($params);
        
        if(isset($result[0])) 
            return $result[0];
        else
            return null;
    }
    
    public function retornaHierarquiaValida($nrorg, $nrtpestrut, $nrtipoestrutrel = null){
        $hierarqorg = Repositories::HIERARQUIAORG;
        $tphierarqorg = Repositories::TIPOHIERARQORG;
        $ultimoDiaCompetencia = $this->hcmParameters->getUltimoDiaMes();
                        
        $sql = <<<SQL
SELECT m
FROM $hierarqorg m
    JOIN $tphierarqorg tph WITH tph.nrtipoestrutsup = :p_tpestrut
                        AND tph.nrtipohierarqorg = m.nrtipohierarqorg
                           AND (tph.nrtipoestrutrel = :p_nrtipoestrutrel OR :p_nrtipoestrutrel IS NULL)
                           AND ( tph.nrorg = :p_nrorg
                                 OR tph.nrorg = 0 )
WHERE m.dtinivigencia <= :p_ultdiamescompetenc
    AND (m.idativo = 'S' OR m.idativo IS NULL)
    AND ( m.dtfimvigencia >= :p_dtmescompetenc OR m.dtfimvigencia IS NULL )
    AND m.nrorg = :p_nrorg
SQL;
        
        $params = array('p_nrorg' => $nrorg,
                        'p_dtmescompetenc' => $this->hcmParameters->getDtCompetencia(),
                        'p_tpestrut' => $nrtpestrut,
                        'p_ultdiamescompetenc' => $ultimoDiaCompetencia,
                        'p_nrtipoestrutrel' => $nrtipoestrutrel);
        
        $resultado = $this->entityManager->createQuery($sql)->execute($params);
        return $resultado;
    }
    
        public function retornaHierarquiaValidaPorEstrutura($nrorg, $nrestrutsup, $nrestrutrel, $nrtpestrut, $nrtipoestrutrel = null){
        $hierarqorg = Repositories::HIERARQUIAORG;
        $tphierarqorg = Repositories::TIPOHIERARQORG;
        $ultimoDiaCompetencia = $this->hcmParameters->getUltimoDiaMes();
                        
        $sql = <<<SQL
SELECT m
FROM $hierarqorg m
    JOIN $tphierarqorg tph WITH tph.nrtipoestrutsup = :p_tpestrut
                        AND tph.nrtipohierarqorg = m.nrtipohierarqorg
                           AND (tph.nrtipoestrutrel = :p_nrtipoestrutrel OR :p_nrtipoestrutrel IS NULL)
                           AND ( tph.nrorg = :p_nrorg
                                 OR tph.nrorg = 0 )
WHERE m.dtinivigencia <= :p_ultdiamescompetenc
    AND (m.idativo = 'S' OR m.idativo IS NULL)
    AND m.nrestruturamsup = :p_nrestrutsup
    AND m.nrestruturamrel = :p_nrestrutrel
    AND ( m.dtfimvigencia >= :p_dtmescompetenc OR m.dtfimvigencia IS NULL )
    AND m.nrorg = :p_nrorg
SQL;
        
        $params = array('p_nrorg' => $nrorg,
                        'p_dtmescompetenc' => $this->hcmParameters->getDtCompetencia(),
                        'p_tpestrut' => $nrtpestrut,
                        'p_ultdiamescompetenc' => $ultimoDiaCompetencia,
                        'p_nrtipoestrutrel' => $nrtipoestrutrel,
                        'p_nrestrutsup' => $nrestrutsup,
                        'p_nrestrutrel' => $nrestrutrel);
                        
        $resultado = $this->entityManager->createQuery($sql)->execute($params);
        return $resultado;
    }

    public function retornaProximaMovimentacaoPorTipoestrutura($nrorg, $nrvinculom, $tipoestrutura, $dtinimoviment, $nrtipotransfer = null) {

        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'nrtipoestrutura'=>$tipoestrutura, 'dtinimoviment'=>$dtinimoviment, 'nrtipotransfer'=>$nrtipotransfer);

        $sql = <<<SQL

SELECT m
  FROM $gpeMovimentacao m
WHERE m.nrorg         = :nrorg
  AND m.nrvinculom    = :nrvinculom
  AND m.nrtipoestrutura = :nrtipoestrutura
  AND m.dtinimoviment = (SELECT MIN(b.dtinimoviment)
                         FROM $gpeMovimentacao b
                       WHERE b.nrorg       = m.nrorg
                         AND b.nrvinculom  = m.nrvinculom
                         AND b.nrtipoestrutura = m.nrtipoestrutura
                         AND b.dtinimoviment > :dtinimoviment
                         AND (b.nrtipotransfer = :nrtipotransfer OR :nrtipotransfer IS NULL))

SQL;
        $resultado = $this->entityManager->createQuery($sql)->execute($params);
        return empty($resultado) ?  null : $resultado[0];
    }

    public function getMovimentacoesPorEstrutura($nrorg, $dtmescompetencia, $nrestrutura, $nrtipoestrutura, $listavinculos = null, $nrtipotransfer) {

        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $gpeVinculom = Repositories::GPE_VINCULOM;

        if($listavinculos == 'A'){
            $queryvinculos = "";
        }elseif($listavinculos == 'N'){
            $queryvinculos = "AND 1 = 2";
        }
        else{
            $queryvinculos = "AND m.nrvinculom IN($listavinculos)";
        }
        $sql = "SELECT m
                  FROM $gpeMovimentacao m
                  WHERE m.nrorg  = :nrorg
                  AND m.nrtipoestrutura = :nrtipoestrutura
                  AND m.nrestruturam = :nrestruturam
                  AND m.nrtipotransfer = :nrtipotransfer
                  $queryvinculos
                  AND m.dtinimoviment = (SELECT MAX(MAX_MOVIMENTACAO.dtinimoviment)
                                          FROM $gpeMovimentacao MAX_MOVIMENTACAO
                                         WHERE MAX_MOVIMENTACAO.nrorg   = m.nrorg
                                           AND MAX_MOVIMENTACAO.nrtipoestrutura = m.nrtipoestrutura
                                           AND MAX_MOVIMENTACAO.nrvinculom = m.nrvinculom
                                           AND MAX_MOVIMENTACAO.dtinimoviment  <= :dtinimoviment
                                           AND MAX_MOVIMENTACAO.nrtipotransfer = :nrtipotransfer)
                  AND EXISTS (SELECT VINCULO.nrvinculom
                             FROM  $gpeVinculom VINCULO
                            WHERE VINCULO.nrorg      = m.nrorg
                              AND VINCULO.nrvinculom = m.nrvinculom
                              AND VINCULO.dtrescisaovinc IS NULL)";
        $params = array('nrorg'=>$nrorg, 'nrtipoestrutura'=>$nrtipoestrutura, 'nrestruturam'=>$nrestrutura, 'nrtipotransfer'=>$nrtipotransfer, 'dtinimoviment'=>$dtmescompetencia);
        $movimentacoes = $this->entityManager->createQuery($sql)->execute($params);
        return $movimentacoes;
    }
    
    public function getMovimentacoesCaged($nrorg, $nrtipoestrutura, $nrvinculom, $nrestrutlegal) {
        $dtultdcompetenc = $this->hcmParameters->getUltimoDiaMes();
        $dtmescompetencia = $this->hcmParameters->getDtCompetencia();
        $gpeMovimentacao = Repositories::GPE_MOVIMENTACAO;
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom, 'nrtipoestrutura'=>$nrtipoestrutura, 'dtmescompetenc'=>$dtmescompetencia,'dtultdcompetenc' =>$dtultdcompetenc);
        $cond_estrut = ($nrestrutlegal==null ? "AND m.dtfimmoviment IS NULL" : "AND m.nrestruturam = $nrestrutlegal");
        $sql = <<<SQL

SELECT m
  FROM $gpeMovimentacao m
WHERE m.nrorg         = :nrorg
  AND m.nrvinculom    = :nrvinculom
  AND m.nrtipotransfer = 1
  AND m.nrtipoestrutura = :nrtipoestrutura
  $cond_estrut
  AND m.dtinimoviment in (SELECT b.dtinimoviment
                         FROM $gpeMovimentacao b
                       WHERE b.nrorg       = m.nrorg
                         AND b.nrvinculom  = m.nrvinculom
                         AND m.nrtipotransfer = m.nrtipotransfer
                         AND b.nrtipoestrutura = m.nrtipoestrutura
                         $cond_estrut
                         AND b.dtinimoviment BETWEEN :dtmescompetenc AND :dtultdcompetenc)

SQL;
        $resultado = $this->entityManager->createQuery($sql)->execute($params);
        return empty($resultado) ?  null : $resultado;
    }

} 
