<?php

namespace HCM\VAB\IntegracaoVT;

class LeitorDireto extends Leitor
{
    protected $formatosAceitos = 'XLSX|XLSM|XLTX|XLTM|XLS|XLT|ODS|OTS|SLK|XML';

    protected function abrirArquivo( $caminho)
    {
        $info = \PHPExcel_IOFactory::load($caminho);
        $info->setActiveSheetIndex(0);

        return $info;
    }


    protected function preparaInfo( $info) {
        $idLinha = 7;
        $idColCartao = 'A';
        $idColNome = 'C';
        $idColMatricula = 'G';
        $idColSaldo = 'R';
        //$idColTipo = 'C';
        $infoFinal = array();

        $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
        $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
        $matricula = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
        $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
        //$tipo = $info->getActiveSheet()->getCell($idColTipo.$idLinha)->getValue();
        $idLinha++;
        while(!empty($numCartao)){
            $reg = array();
            $reg['NUMERO_CARTAO'] = $this->retornaAlfaNum($numCartao);
            $reg['SALDO_CARTAO'] = $saldo;
            $reg['MATRICULA'] = $matricula;
            $reg['NOME'] = $nome;
            //$reg['TIPO'] = $tipo;

            $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
            $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
            $matricula = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
            $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
            //$tipo = $info->getActiveSheet()->getCell($idColTipo.$idLinha)->getValue();
            $idLinha++;

            $infoFinal[] = $reg;
        }

        return $infoFinal;
    }
    
    public function retornaAlfaNum($str) {
        return preg_replace("/[^0-9a-zA-Z]/", "", $str);
    }
    
}